#!perl -T

use Test::More tests => 3;

BEGIN {
	use_ok( 'OpenSRF::Utils::Logger' );
}

my $msg = OpenSRF::Utils::Logger::_log_message('this is a message', OpenSRF::Utils::Logger::INFO());
like($msg, qr/this is a message/, 'can use a string as a log message');

$msg = OpenSRF::Utils::Logger::_log_message(
    sub { return 'this is a message generated by a subroutine' },
    OpenSRF::Utils::Logger::INFO()
);
like($msg, qr/generated by a subroutine/, 'can use a subroutine as a log message');
